﻿using System;
using Dapper;
using System.Web;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.XlsIO;
using Syncfusion.EJ.Export;
using Models;
using Syncfusion.JavaScript.Web;
using System.Data.SqlClient;
using System.Configuration;
using System.Data;

public partial class Yacht_Event_History : BandPage
{


    #region Sql

    private readonly string GetYachtEventHistory = @"
            DECLARE @entity int; SET @entity = {$EntityID}

           	    select top 50
                y.Ext_Yacht_Event_Type_ID, y.Boat_ID, y.Varchar_Value, y.Decimal_Value, y.Date_Value, y.Created_Date, y.Notes, y.EXT_Yacht_Event_ID,
                u.Project_ID, EXT_Boat_ID, u.Estimated_Total_Hours,
				p.Project_ID, p.Name
                FROM EXT_Yacht_Event y
				INNER JOIN Project_UDF u on y.Boat_ID = u.EXT_Boat_ID
				INNER JOIN Project p on p.Project_ID = u.Project_ID
				where
                p.Project_ID={$Entity.ID}

                order by y.Created_Date desc";

    #endregion Sql

    //#region Sql

    //private readonly string SaveYachtEvent = @"

    //    DECLARE @entityID  varchar(50)
    //    INSERT INTO EXT_Yacht_Event_History WHERE  Project_ID = @projectid
    //    (EXT_Yacht_Event_Type_ID, Boat_ID, Approval_Action, Varchar_Value, Decimal_Value, Date_Value, Created_Date, notes, EXT_Yacht_Event_ID)
    //    VALUES(3,@boat_id,44,44,GETDATE(),GETDATE(),@notes,@newid)";

    //#endregion




    //public IEnumerable<YachtEvents> GetYachtEventHistoryDetails()
    //{
    //    using (var connection = ConnectionService.CreateConnection())
    //    {
    //        var eventHistory = connection.Query<YachtEvents>(GetYachtEventHistory, new { Entity = Entity.EntityID });


    //        eventHistory = eventHistory.ToList();


    //        return eventHistory;
    //    }

    //}



    protected void Grid_ServerExcelExporting(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
    {
        BindGrid();

        new ExcelExport().Export(Grid.Model, Grid.DataSource, "Export.xlsx", ExcelVersion.Excel2010, false, false, ExportTheme.BootstrapTheme);
    }

    //private void Save(string YachtEvent)
    //{
    //    using (var connection = ConnectionService.CreateConnection())
    //    {
    //        connection.Execute(SaveYachtEvent, new { user = UserID.Value, YachtEvent = YachtEvent });
    //    }
    //}

    protected void Page_Load(object sender, EventArgs e)
    {

        BindGrid();

    }

    private void BindGrid()
    {
        Grid.DataBind();
    }

    protected void EditEvents_ServerEditRow(object sender, GridEventArgs e)

    {

        EditAction(e.EventType, e.Arguments["data"]);

    }

    //Server side add record

    protected void EditEvents_ServerAddRow(object sender, GridEventArgs e)

    {

        EditAction(e.EventType, e.Arguments["data"]);

    }


    //Server side delete record

    protected void EditEvents_ServerDeleteRow(object sender, GridEventArgs e)

    {

        //   EditAction(e.EventType, e.Arguments["data"]);

    }



    protected void EditAction(string eventType, object record)

    {

        Dictionary<string, object> KeyVal = record as Dictionary<string, object>;

        if (eventType == "endEdit")

        {

            //-------   

            //-------

        }



        else if (eventType == "endAdd")

        {

            //--------

            //--------

        }



        else if (eventType == "endDelete")

        {

            //-------

            //-------

        }

        this.Grid.DataBind();

    }

}
